<?php
/**
 * ###############################################
 *
 * SWIFT Framework
 * _______________________________________________
 *
 * @author         Varun Shoor
 *
 * @package        SWIFT
 * @copyright      Copyright (c) 2001-2012, Kayako
 * @license        http://www.kayako.com/license
 * @link           http://www.kayako.com
 *
 * ###############################################
 */
if (!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once('include/MVC/View/SugarView.php');
require_once('modules/ky_Tickets/KayakoHelper.php');

class ViewConfig extends SugarView
{
	public function preDisplay()
	{
		global $current_user;

		if (!is_admin($current_user)) {
			sugar_die("No access");
		}
	}

	public function display()
	{
		$admin = new Administration();
		$admin->retrieveSettings('kayako');

		if (!isset($admin->settings['system_kayako_url']) || !isset($admin->settings['system_kayako_api']) || !isset($admin->settings['system_kayako_key'])) {
			$this->ss->display('modules/ky_Tickets/tpls/config.tpl');
		} else {
			echo $this->getModuleTitle();

			$this->ss->assign("RETURN_MODULE", $_REQUEST['module']);
			$this->ss->assign("RETURN_ACTION", "settingmanager");

			$admin = new Administration();
			$admin->retrieveSettings('kayako');
			$this->ss->assign('kayako_url', $admin->settings['system_kayako_url']);
			$this->ss->assign('kayako_api', $admin->settings['system_kayako_api']);
			$this->ss->assign('kayako_secret', $admin->settings['system_kayako_key']);

			$this->ss->display('modules/ky_Tickets/tpls/config.tpl');
		}
	}
}
