<?php
/**
 * ###############################################
 *
 * SWIFT Framework
 * _______________________________________________
 *
 * @author         Varun Shoor
 *
 * @package        SWIFT
 * @copyright      Copyright (c) 2001-2012, Kayako
 * @license        http://www.kayako.com/license
 * @link           http://www.kayako.com
 *
 * ###############################################
 */
if (!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once('include/MVC/View/views/view.list.php');
require_once('modules/ky_Tickets/KayakoConnection.php');

class ViewTickets extends SugarView
{
	/**
	 * email of requester
	 *
	 * @var string
	 */
	public $requesters;
	/**
	 * referrer module
	 *
	 * @var string
	 */
	public $referrer;

	function ViewTickets()
	{
		parent::SugarView();

		switch ($_REQUEST['return_module']) {
			case 'Leads':
				$this->referrer = new Lead();
				$this->referrer->retrieve($_REQUEST['record']);
				$this->requesters = array($this->referrer->email1 => $this->referrer->name);
				break;
			case 'Contacts':
				$this->referrer = new Contact();
				$this->referrer->retrieve($_REQUEST['record']);
				$this->requesters = array($this->referrer->email1 => $this->referrer->name);
				break;
		}
	}

	public function display()
	{
		global $current_user;

		$isAdmin = false;

		$admin = new Administration();
		$admin->retrieveSettings('kayako');

		if (is_admin($current_user)) {
			$isAdmin = true;
		}

		if (!isset($admin->settings['system_kayako_url']) || !isset($admin->settings['system_kayako_api']) || !isset($admin->settings['system_kayako_key'])) {
			$link = 'index.php?module=ky_Tickets&action=settingmanager&return_module=' . $_REQUEST['return_module'] . '&return_id=' . $_REQUEST['return_id'] . '&return_action=' . $_REQUEST['return_action'];
			echo "Please <a href='$link'>configure your Kayako Configuaration Settings</a> to edit or create tickets.";
		} else {
			global $db;
			$isConverted = false;

			$result = $db->query("SELECT id FROM ky_tickets WHERE id = '" . $_REQUEST['record'] . "'");
			while ($row = $db->fetchByAssoc($result))
			{
				if ($row['id'] == $_REQUEST['record'])
				{
					$isConverted = true;
					break;
				}
			}

			$connection        = new KayakoConnection($admin->settings['system_kayako_url'], $admin->settings['system_kayako_api'], $admin->settings['system_kayako_key']);
			$connection->email = $this->referrer->email1;
			$connection->view();
			$ticketObject = $connection->tickets;

			$counter = 0;
			$this->ss->assign('isAdmin', $isAdmin);
			$this->ss->assign('isConverted', $isConverted);

			$this->ss->assign('record', $_REQUEST['record']);
			$this->ss->assign('module', $_REQUEST['return_module']);
			$this->ss->assign('return_module', $_REQUEST['return_module']);
			$this->ss->assign('return_action', $_REQUEST['return_action']);

			$ticketContainer = array();
			if (count($ticketObject) > 0) {
				foreach ($ticketObject as $list) {
					$ticketContainer[$counter]['displayid']    = $list->getDisplayId();
					$ticketContainer[$counter]['lastactivity'] = date('M d, Y h:i A', strtotime($list->getLastActivity()));
					$ticketContainer[$counter]['department']   = kyDepartment::get($list->getDepartmentId())->getTitle();
					$ticketContainer[$counter]['type']         = kyTicketType::get($list->getTypeId())->getTitle();
					$ticketContainer[$counter]['status']       = kyTicketStatus::get($list->getStatusId())->getTitle();
					$ticketContainer[$counter]['priority']     = kyTicketPriority::get($list->getPriorityId())->getTitle();
					$ticketContainer[$counter]['id']           = $list->getId();
					$ticketContainer[$counter]['view_url']     = $this->parseUrl($admin->settings['system_kayako_url']) . "/Tickets/Ticket/View/" . $list->getId();
					$ticketContainer[$counter++]['subject']    = $list->getSubject();
				}
				$this->ss->assign('ticketContainer', $ticketContainer);
			} else {
				$this->ss->assign('ticketContainer', 'empty');
			}

			$this->ss->display('modules/ky_Tickets/tpls/tickets.tpl');
		}
	}

	private function parseUrl($url)
	{
		$parsedUrl = parse_url($url);

		$parsedUrl['scheme'] .= '://';
		if (stristr($parsedUrl['path'], 'api')) {
			$parsedUrl['path'] = str_replace('/api', '/staff', $parsedUrl['path']);

			return implode($parsedUrl);
		}
	}
}
